/*
 * Copyright 2024 Intel Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sub license, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.
 * IN NO EVENT SHALL VMWARE AND/OR ITS SUPPLIERS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


/* DO NOT EDIT - This file generated automatically by intel_device_serialize_c.py script */

#include "dev/intel_device_info_serialize.h"
#include "util/parson.h"

static JSON_Value *
dump_intel_platform(enum intel_platform arg) {
   switch (arg) {
   case INTEL_PLATFORM_GFX3:
      return json_value_init_string("INTEL_PLATFORM_GFX3");
   case INTEL_PLATFORM_I965:
      return json_value_init_string("INTEL_PLATFORM_I965");
   case INTEL_PLATFORM_ILK:
      return json_value_init_string("INTEL_PLATFORM_ILK");
   case INTEL_PLATFORM_G4X:
      return json_value_init_string("INTEL_PLATFORM_G4X");
   case INTEL_PLATFORM_SNB:
      return json_value_init_string("INTEL_PLATFORM_SNB");
   case INTEL_PLATFORM_IVB:
      return json_value_init_string("INTEL_PLATFORM_IVB");
   case INTEL_PLATFORM_BYT:
      return json_value_init_string("INTEL_PLATFORM_BYT");
   case INTEL_PLATFORM_HSW:
      return json_value_init_string("INTEL_PLATFORM_HSW");
   case INTEL_PLATFORM_BDW:
      return json_value_init_string("INTEL_PLATFORM_BDW");
   case INTEL_PLATFORM_CHV:
      return json_value_init_string("INTEL_PLATFORM_CHV");
   case INTEL_PLATFORM_SKL:
      return json_value_init_string("INTEL_PLATFORM_SKL");
   case INTEL_PLATFORM_BXT:
      return json_value_init_string("INTEL_PLATFORM_BXT");
   case INTEL_PLATFORM_KBL:
      return json_value_init_string("INTEL_PLATFORM_KBL");
   case INTEL_PLATFORM_GLK:
      return json_value_init_string("INTEL_PLATFORM_GLK");
   case INTEL_PLATFORM_CFL:
      return json_value_init_string("INTEL_PLATFORM_CFL");
   case INTEL_PLATFORM_ICL:
      return json_value_init_string("INTEL_PLATFORM_ICL");
   case INTEL_PLATFORM_EHL:
      return json_value_init_string("INTEL_PLATFORM_EHL");
   case INTEL_PLATFORM_TGL:
      return json_value_init_string("INTEL_PLATFORM_TGL");
   case INTEL_PLATFORM_RKL:
      return json_value_init_string("INTEL_PLATFORM_RKL");
   case INTEL_PLATFORM_DG1:
      return json_value_init_string("INTEL_PLATFORM_DG1");
   case INTEL_PLATFORM_ADL:
      return json_value_init_string("INTEL_PLATFORM_ADL");
   case INTEL_PLATFORM_RPL:
      return json_value_init_string("INTEL_PLATFORM_RPL");
   case INTEL_PLATFORM_DG2_G10:
      return json_value_init_string("INTEL_PLATFORM_DG2_G10");
   case INTEL_PLATFORM_DG2_G11:
      return json_value_init_string("INTEL_PLATFORM_DG2_G11");
   case INTEL_PLATFORM_DG2_G12:
      return json_value_init_string("INTEL_PLATFORM_DG2_G12");
   case INTEL_PLATFORM_ATSM_G10:
      return json_value_init_string("INTEL_PLATFORM_ATSM_G10");
   case INTEL_PLATFORM_ATSM_G11:
      return json_value_init_string("INTEL_PLATFORM_ATSM_G11");
   case INTEL_PLATFORM_MTL_U:
      return json_value_init_string("INTEL_PLATFORM_MTL_U");
   case INTEL_PLATFORM_MTL_H:
      return json_value_init_string("INTEL_PLATFORM_MTL_H");
   case INTEL_PLATFORM_ARL_U:
      return json_value_init_string("INTEL_PLATFORM_ARL_U");
   case INTEL_PLATFORM_ARL_H:
      return json_value_init_string("INTEL_PLATFORM_ARL_H");
   case INTEL_PLATFORM_LNL:
      return json_value_init_string("INTEL_PLATFORM_LNL");
   case INTEL_PLATFORM_BMG:
      return json_value_init_string("INTEL_PLATFORM_BMG");
   case INTEL_PLATFORM_PTL:
      return json_value_init_string("INTEL_PLATFORM_PTL");
   case INTEL_PLATFORM_WCL:
      return json_value_init_string("INTEL_PLATFORM_WCL");
   default:
      unreachable("invalid intel_platform value");
   }
}

static enum intel_platform
load_intel_platform(const char * val) {
   if (strcmp("INTEL_PLATFORM_GFX3", val) == 0)
      return INTEL_PLATFORM_GFX3;
   if (strcmp("INTEL_PLATFORM_I965", val) == 0)
      return INTEL_PLATFORM_I965;
   if (strcmp("INTEL_PLATFORM_ILK", val) == 0)
      return INTEL_PLATFORM_ILK;
   if (strcmp("INTEL_PLATFORM_G4X", val) == 0)
      return INTEL_PLATFORM_G4X;
   if (strcmp("INTEL_PLATFORM_SNB", val) == 0)
      return INTEL_PLATFORM_SNB;
   if (strcmp("INTEL_PLATFORM_IVB", val) == 0)
      return INTEL_PLATFORM_IVB;
   if (strcmp("INTEL_PLATFORM_BYT", val) == 0)
      return INTEL_PLATFORM_BYT;
   if (strcmp("INTEL_PLATFORM_HSW", val) == 0)
      return INTEL_PLATFORM_HSW;
   if (strcmp("INTEL_PLATFORM_BDW", val) == 0)
      return INTEL_PLATFORM_BDW;
   if (strcmp("INTEL_PLATFORM_CHV", val) == 0)
      return INTEL_PLATFORM_CHV;
   if (strcmp("INTEL_PLATFORM_SKL", val) == 0)
      return INTEL_PLATFORM_SKL;
   if (strcmp("INTEL_PLATFORM_BXT", val) == 0)
      return INTEL_PLATFORM_BXT;
   if (strcmp("INTEL_PLATFORM_KBL", val) == 0)
      return INTEL_PLATFORM_KBL;
   if (strcmp("INTEL_PLATFORM_GLK", val) == 0)
      return INTEL_PLATFORM_GLK;
   if (strcmp("INTEL_PLATFORM_CFL", val) == 0)
      return INTEL_PLATFORM_CFL;
   if (strcmp("INTEL_PLATFORM_ICL", val) == 0)
      return INTEL_PLATFORM_ICL;
   if (strcmp("INTEL_PLATFORM_EHL", val) == 0)
      return INTEL_PLATFORM_EHL;
   if (strcmp("INTEL_PLATFORM_TGL", val) == 0)
      return INTEL_PLATFORM_TGL;
   if (strcmp("INTEL_PLATFORM_RKL", val) == 0)
      return INTEL_PLATFORM_RKL;
   if (strcmp("INTEL_PLATFORM_DG1", val) == 0)
      return INTEL_PLATFORM_DG1;
   if (strcmp("INTEL_PLATFORM_ADL", val) == 0)
      return INTEL_PLATFORM_ADL;
   if (strcmp("INTEL_PLATFORM_RPL", val) == 0)
      return INTEL_PLATFORM_RPL;
   if (strcmp("INTEL_PLATFORM_DG2_G10", val) == 0)
      return INTEL_PLATFORM_DG2_G10;
   if (strcmp("INTEL_PLATFORM_DG2_G11", val) == 0)
      return INTEL_PLATFORM_DG2_G11;
   if (strcmp("INTEL_PLATFORM_DG2_G12", val) == 0)
      return INTEL_PLATFORM_DG2_G12;
   if (strcmp("INTEL_PLATFORM_ATSM_G10", val) == 0)
      return INTEL_PLATFORM_ATSM_G10;
   if (strcmp("INTEL_PLATFORM_ATSM_G11", val) == 0)
      return INTEL_PLATFORM_ATSM_G11;
   if (strcmp("INTEL_PLATFORM_MTL_U", val) == 0)
      return INTEL_PLATFORM_MTL_U;
   if (strcmp("INTEL_PLATFORM_MTL_H", val) == 0)
      return INTEL_PLATFORM_MTL_H;
   if (strcmp("INTEL_PLATFORM_ARL_U", val) == 0)
      return INTEL_PLATFORM_ARL_U;
   if (strcmp("INTEL_PLATFORM_ARL_H", val) == 0)
      return INTEL_PLATFORM_ARL_H;
   if (strcmp("INTEL_PLATFORM_LNL", val) == 0)
      return INTEL_PLATFORM_LNL;
   if (strcmp("INTEL_PLATFORM_BMG", val) == 0)
      return INTEL_PLATFORM_BMG;
   if (strcmp("INTEL_PLATFORM_PTL", val) == 0)
      return INTEL_PLATFORM_PTL;
   if (strcmp("INTEL_PLATFORM_WCL", val) == 0)
      return INTEL_PLATFORM_WCL;
   assert(false);
   return (enum intel_platform) -1;
}

static JSON_Value *
dump_intel_memory_class_instance(const struct intel_memory_class_instance *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_number(json, "klass", arg->klass);
   json_object_set_number(json, "instance", arg->instance);
   return val;
}

static void
load_intel_memory_class_instance(JSON_Object *json, struct intel_memory_class_instance *target) {
   target->klass = json_object_get_number(json, "klass");
   target->instance = json_object_get_number(json, "instance");
}

static JSON_Value *
dump_intel_device_info_mmap_mode(enum intel_device_info_mmap_mode arg) {
   switch (arg) {
   case INTEL_DEVICE_INFO_MMAP_MODE_UC:
      return json_value_init_string("INTEL_DEVICE_INFO_MMAP_MODE_UC");
   case INTEL_DEVICE_INFO_MMAP_MODE_WC:
      return json_value_init_string("INTEL_DEVICE_INFO_MMAP_MODE_WC");
   case INTEL_DEVICE_INFO_MMAP_MODE_WB:
      return json_value_init_string("INTEL_DEVICE_INFO_MMAP_MODE_WB");
   case INTEL_DEVICE_INFO_MMAP_MODE_XD:
      return json_value_init_string("INTEL_DEVICE_INFO_MMAP_MODE_XD");
   default:
      unreachable("invalid intel_device_info_mmap_mode value");
   }
}

static enum intel_device_info_mmap_mode
load_intel_device_info_mmap_mode(const char * val) {
   if (strcmp("INTEL_DEVICE_INFO_MMAP_MODE_UC", val) == 0)
      return INTEL_DEVICE_INFO_MMAP_MODE_UC;
   if (strcmp("INTEL_DEVICE_INFO_MMAP_MODE_WC", val) == 0)
      return INTEL_DEVICE_INFO_MMAP_MODE_WC;
   if (strcmp("INTEL_DEVICE_INFO_MMAP_MODE_WB", val) == 0)
      return INTEL_DEVICE_INFO_MMAP_MODE_WB;
   if (strcmp("INTEL_DEVICE_INFO_MMAP_MODE_XD", val) == 0)
      return INTEL_DEVICE_INFO_MMAP_MODE_XD;
   assert(false);
   return (enum intel_device_info_mmap_mode) -1;
}

static JSON_Value *
dump_intel_device_info_pat_entry(const struct intel_device_info_pat_entry *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_number(json, "index", arg->index);
   json_object_set_value(json, "mmap", dump_intel_device_info_mmap_mode(arg->mmap));
   return val;
}

static void
load_intel_device_info_pat_entry(JSON_Object *json, struct intel_device_info_pat_entry *target) {
   target->index = json_object_get_number(json, "index");
   target->mmap = load_intel_device_info_mmap_mode(json_object_get_string(json, "mmap"));
}

static JSON_Value *
dump_intel_cmat_scope(enum intel_cmat_scope arg) {
   switch (arg) {
   case INTEL_CMAT_SCOPE_NONE:
      return json_value_init_string("INTEL_CMAT_SCOPE_NONE");
   case INTEL_CMAT_SCOPE_SUBGROUP:
      return json_value_init_string("INTEL_CMAT_SCOPE_SUBGROUP");
   default:
      unreachable("invalid intel_cmat_scope value");
   }
}

static enum intel_cmat_scope
load_intel_cmat_scope(const char * val) {
   if (strcmp("INTEL_CMAT_SCOPE_NONE", val) == 0)
      return INTEL_CMAT_SCOPE_NONE;
   if (strcmp("INTEL_CMAT_SCOPE_SUBGROUP", val) == 0)
      return INTEL_CMAT_SCOPE_SUBGROUP;
   assert(false);
   return (enum intel_cmat_scope) -1;
}

static JSON_Value *
dump_intel_cooperative_matrix_component_type(enum intel_cooperative_matrix_component_type arg) {
   switch (arg) {
   case INTEL_CMAT_FLOAT16:
      return json_value_init_string("INTEL_CMAT_FLOAT16");
   case INTEL_CMAT_FLOAT32:
      return json_value_init_string("INTEL_CMAT_FLOAT32");
   case INTEL_CMAT_SINT32:
      return json_value_init_string("INTEL_CMAT_SINT32");
   case INTEL_CMAT_SINT8:
      return json_value_init_string("INTEL_CMAT_SINT8");
   case INTEL_CMAT_UINT32:
      return json_value_init_string("INTEL_CMAT_UINT32");
   case INTEL_CMAT_UINT8:
      return json_value_init_string("INTEL_CMAT_UINT8");
   case INTEL_CMAT_BFLOAT16:
      return json_value_init_string("INTEL_CMAT_BFLOAT16");
   default:
      unreachable("invalid intel_cooperative_matrix_component_type value");
   }
}

static enum intel_cooperative_matrix_component_type
load_intel_cooperative_matrix_component_type(const char * val) {
   if (strcmp("INTEL_CMAT_FLOAT16", val) == 0)
      return INTEL_CMAT_FLOAT16;
   if (strcmp("INTEL_CMAT_FLOAT32", val) == 0)
      return INTEL_CMAT_FLOAT32;
   if (strcmp("INTEL_CMAT_SINT32", val) == 0)
      return INTEL_CMAT_SINT32;
   if (strcmp("INTEL_CMAT_SINT8", val) == 0)
      return INTEL_CMAT_SINT8;
   if (strcmp("INTEL_CMAT_UINT32", val) == 0)
      return INTEL_CMAT_UINT32;
   if (strcmp("INTEL_CMAT_UINT8", val) == 0)
      return INTEL_CMAT_UINT8;
   if (strcmp("INTEL_CMAT_BFLOAT16", val) == 0)
      return INTEL_CMAT_BFLOAT16;
   assert(false);
   return (enum intel_cooperative_matrix_component_type) -1;
}

static JSON_Value *
dump_intel_engine_class(enum intel_engine_class arg) {
   switch (arg) {
   case INTEL_ENGINE_CLASS_RENDER:
      return json_value_init_string("INTEL_ENGINE_CLASS_RENDER");
   case INTEL_ENGINE_CLASS_COPY:
      return json_value_init_string("INTEL_ENGINE_CLASS_COPY");
   case INTEL_ENGINE_CLASS_VIDEO:
      return json_value_init_string("INTEL_ENGINE_CLASS_VIDEO");
   case INTEL_ENGINE_CLASS_VIDEO_ENHANCE:
      return json_value_init_string("INTEL_ENGINE_CLASS_VIDEO_ENHANCE");
   case INTEL_ENGINE_CLASS_COMPUTE:
      return json_value_init_string("INTEL_ENGINE_CLASS_COMPUTE");
   case INTEL_ENGINE_CLASS_INVALID:
      return json_value_init_string("INTEL_ENGINE_CLASS_INVALID");
   default:
      unreachable("invalid intel_engine_class value");
   }
}

static enum intel_engine_class
load_intel_engine_class(const char * val) {
   if (strcmp("INTEL_ENGINE_CLASS_RENDER", val) == 0)
      return INTEL_ENGINE_CLASS_RENDER;
   if (strcmp("INTEL_ENGINE_CLASS_COPY", val) == 0)
      return INTEL_ENGINE_CLASS_COPY;
   if (strcmp("INTEL_ENGINE_CLASS_VIDEO", val) == 0)
      return INTEL_ENGINE_CLASS_VIDEO;
   if (strcmp("INTEL_ENGINE_CLASS_VIDEO_ENHANCE", val) == 0)
      return INTEL_ENGINE_CLASS_VIDEO_ENHANCE;
   if (strcmp("INTEL_ENGINE_CLASS_COMPUTE", val) == 0)
      return INTEL_ENGINE_CLASS_COMPUTE;
   if (strcmp("INTEL_ENGINE_CLASS_INVALID", val) == 0)
      return INTEL_ENGINE_CLASS_INVALID;
   assert(false);
   return (enum intel_engine_class) -1;
}

static JSON_Value *
dump_intel_cooperative_matrix_configuration(const struct intel_cooperative_matrix_configuration *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_value(json, "scope", dump_intel_cmat_scope(arg->scope));
   json_object_set_number(json, "m", arg->m);
   json_object_set_number(json, "n", arg->n);
   json_object_set_number(json, "k", arg->k);
   json_object_set_value(json, "a", dump_intel_cooperative_matrix_component_type(arg->a));
   json_object_set_value(json, "b", dump_intel_cooperative_matrix_component_type(arg->b));
   json_object_set_value(json, "c", dump_intel_cooperative_matrix_component_type(arg->c));
   json_object_set_value(json, "result", dump_intel_cooperative_matrix_component_type(arg->result));
   return val;
}

static void
load_intel_cooperative_matrix_configuration(JSON_Object *json, struct intel_cooperative_matrix_configuration *target) {
   target->scope = load_intel_cmat_scope(json_object_get_string(json, "scope"));
   target->m = json_object_get_number(json, "m");
   target->n = json_object_get_number(json, "n");
   target->k = json_object_get_number(json, "k");
   target->a = load_intel_cooperative_matrix_component_type(json_object_get_string(json, "a"));
   target->b = load_intel_cooperative_matrix_component_type(json_object_get_string(json, "b"));
   target->c = load_intel_cooperative_matrix_component_type(json_object_get_string(json, "c"));
   target->result = load_intel_cooperative_matrix_component_type(json_object_get_string(json, "result"));
}

static JSON_Value *
dump_intel_kmd_type(enum intel_kmd_type arg) {
   switch (arg) {
   case INTEL_KMD_TYPE_INVALID:
      return json_value_init_string("INTEL_KMD_TYPE_INVALID");
   case INTEL_KMD_TYPE_I915:
      return json_value_init_string("INTEL_KMD_TYPE_I915");
   case INTEL_KMD_TYPE_XE:
      return json_value_init_string("INTEL_KMD_TYPE_XE");
   case INTEL_KMD_TYPE_STUB:
      return json_value_init_string("INTEL_KMD_TYPE_STUB");
   case INTEL_KMD_TYPE_LAST:
      return json_value_init_string("INTEL_KMD_TYPE_LAST");
   default:
      unreachable("invalid intel_kmd_type value");
   }
}

static enum intel_kmd_type
load_intel_kmd_type(const char * val) {
   if (strcmp("INTEL_KMD_TYPE_INVALID", val) == 0)
      return INTEL_KMD_TYPE_INVALID;
   if (strcmp("INTEL_KMD_TYPE_I915", val) == 0)
      return INTEL_KMD_TYPE_I915;
   if (strcmp("INTEL_KMD_TYPE_XE", val) == 0)
      return INTEL_KMD_TYPE_XE;
   if (strcmp("INTEL_KMD_TYPE_STUB", val) == 0)
      return INTEL_KMD_TYPE_STUB;
   if (strcmp("INTEL_KMD_TYPE_LAST", val) == 0)
      return INTEL_KMD_TYPE_LAST;
   assert(false);
   return (enum intel_kmd_type) -1;
}

static JSON_Value *
dump_intel_device_info_mem_region(const struct intel_device_info_mem_region *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_number(json, "size", arg->size);
   json_object_set_number(json, "free", arg->free);
   return val;
}

static void
load_intel_device_info_mem_region(JSON_Object *json, struct intel_device_info_mem_region *target) {
   target->size = json_object_get_number(json, "size");
   target->free = json_object_get_number(json, "free");
}

static JSON_Value *
dump_intel_device_info_ram_desc(const struct intel_device_info_ram_desc *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_value(json, "mem", dump_intel_memory_class_instance(&arg->mem));
   json_object_set_value(json, "mappable", dump_intel_device_info_mem_region(&arg->mappable));
   json_object_set_value(json, "unmappable", dump_intel_device_info_mem_region(&arg->unmappable));
   return val;
}

static void
load_intel_device_info_ram_desc(JSON_Object *json, struct intel_device_info_ram_desc *target) {
   load_intel_memory_class_instance(json_object_get_object(json, "mem"), &target->mem);
   load_intel_device_info_mem_region(json_object_get_object(json, "mappable"), &target->mappable);
   load_intel_device_info_mem_region(json_object_get_object(json, "unmappable"), &target->unmappable);
}

static JSON_Value *
dump_intel_device_info_mem_desc(const struct intel_device_info_mem_desc *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_boolean(json, "use_class_instance", arg->use_class_instance);
   json_object_set_value(json, "sram", dump_intel_device_info_ram_desc(&arg->sram));
   json_object_set_value(json, "vram", dump_intel_device_info_ram_desc(&arg->vram));
   return val;
}

static void
load_intel_device_info_mem_desc(JSON_Object *json, struct intel_device_info_mem_desc *target) {
   target->use_class_instance = json_object_get_boolean(json, "use_class_instance");
   load_intel_device_info_ram_desc(json_object_get_object(json, "sram"), &target->sram);
   load_intel_device_info_ram_desc(json_object_get_object(json, "vram"), &target->vram);
}

static JSON_Value *
dump_intel_device_info_urb_desc(const struct intel_device_info_urb_desc *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_number(json, "size", arg->size);
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->min_entries) / sizeof(*arg->min_entries); ++i)
          json_array_append_number(jarray, arg->min_entries[i]);
      json_object_set_value(json, "min_entries", jtmp);
   }
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->max_entries) / sizeof(*arg->max_entries); ++i)
          json_array_append_number(jarray, arg->max_entries[i]);
      json_object_set_value(json, "max_entries", jtmp);
   }
   return val;
}

static void
load_intel_device_info_urb_desc(JSON_Object *json, struct intel_device_info_urb_desc *target) {
   target->size = json_object_get_number(json, "size");
   {
      JSON_Array *array = json_object_get_array(json, "min_entries");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->min_entries[i] = json_array_get_number(array, i);
   }
   {
      JSON_Array *array = json_object_get_array(json, "max_entries");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->max_entries[i] = json_array_get_number(array, i);
   }
}

static JSON_Value *
dump_intel_device_info_pat_desc(const struct intel_device_info_pat_desc *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_value(json, "cached_coherent", dump_intel_device_info_pat_entry(&arg->cached_coherent));
   json_object_set_value(json, "scanout", dump_intel_device_info_pat_entry(&arg->scanout));
   json_object_set_value(json, "compressed_scanout", dump_intel_device_info_pat_entry(&arg->compressed_scanout));
   json_object_set_value(json, "compressed", dump_intel_device_info_pat_entry(&arg->compressed));
   json_object_set_value(json, "writeback_incoherent", dump_intel_device_info_pat_entry(&arg->writeback_incoherent));
   json_object_set_value(json, "writecombining", dump_intel_device_info_pat_entry(&arg->writecombining));
   return val;
}

static void
load_intel_device_info_pat_desc(JSON_Object *json, struct intel_device_info_pat_desc *target) {
   load_intel_device_info_pat_entry(json_object_get_object(json, "cached_coherent"), &target->cached_coherent);
   load_intel_device_info_pat_entry(json_object_get_object(json, "scanout"), &target->scanout);
   load_intel_device_info_pat_entry(json_object_get_object(json, "compressed_scanout"), &target->compressed_scanout);
   load_intel_device_info_pat_entry(json_object_get_object(json, "compressed"), &target->compressed);
   load_intel_device_info_pat_entry(json_object_get_object(json, "writeback_incoherent"), &target->writeback_incoherent);
   load_intel_device_info_pat_entry(json_object_get_object(json, "writecombining"), &target->writecombining);
}

static JSON_Value *
dump_intel_device_info(const struct intel_device_info *arg) {
   JSON_Value *val = json_value_init_object();
   JSON_Object *json = json_object(val);
   json_object_set_value(json, "kmd_type", dump_intel_kmd_type(arg->kmd_type));
   json_object_set_number(json, "ver", arg->ver);
   json_object_set_number(json, "verx10", arg->verx10);
   json_object_set_number(json, "gfx_ip_ver", arg->gfx_ip_ver);
   json_object_set_number(json, "revision", arg->revision);
   json_object_set_number(json, "gt", arg->gt);
   json_object_set_number(json, "pci_domain", arg->pci_domain);
   json_object_set_number(json, "pci_bus", arg->pci_bus);
   json_object_set_number(json, "pci_dev", arg->pci_dev);
   json_object_set_number(json, "pci_func", arg->pci_func);
   json_object_set_number(json, "pci_device_id", arg->pci_device_id);
   json_object_set_number(json, "pci_revision_id", arg->pci_revision_id);
   json_object_set_value(json, "platform", dump_intel_platform(arg->platform));
   json_object_set_boolean(json, "has_hiz_and_separate_stencil", arg->has_hiz_and_separate_stencil);
   json_object_set_boolean(json, "has_sample_with_hiz", arg->has_sample_with_hiz);
   json_object_set_boolean(json, "has_bit6_swizzle", arg->has_bit6_swizzle);
   json_object_set_boolean(json, "has_llc", arg->has_llc);
   json_object_set_boolean(json, "has_pln", arg->has_pln);
   json_object_set_boolean(json, "has_64bit_float", arg->has_64bit_float);
   json_object_set_boolean(json, "has_64bit_float_via_math_pipe", arg->has_64bit_float_via_math_pipe);
   json_object_set_boolean(json, "has_64bit_int", arg->has_64bit_int);
   json_object_set_boolean(json, "has_bfloat16", arg->has_bfloat16);
   json_object_set_boolean(json, "has_integer_dword_mul", arg->has_integer_dword_mul);
   json_object_set_boolean(json, "has_systolic", arg->has_systolic);
   json_object_set_boolean(json, "supports_simd16_3src", arg->supports_simd16_3src);
   json_object_set_boolean(json, "disable_ccs_repack", arg->disable_ccs_repack);
   json_object_set_boolean(json, "has_illegal_ccs_values", arg->has_illegal_ccs_values);
   json_object_set_boolean(json, "has_flat_ccs", arg->has_flat_ccs);
   json_object_set_boolean(json, "has_aux_map", arg->has_aux_map);
   json_object_set_boolean(json, "has_caching_uapi", arg->has_caching_uapi);
   json_object_set_boolean(json, "has_tiling_uapi", arg->has_tiling_uapi);
   json_object_set_boolean(json, "has_ray_tracing", arg->has_ray_tracing);
   json_object_set_boolean(json, "has_ray_query", arg->has_ray_query);
   json_object_set_boolean(json, "has_local_mem", arg->has_local_mem);
   json_object_set_boolean(json, "has_lsc", arg->has_lsc);
   json_object_set_boolean(json, "has_mesh_shading", arg->has_mesh_shading);
   json_object_set_boolean(json, "has_mmap_offset", arg->has_mmap_offset);
   json_object_set_boolean(json, "has_partial_mmap_offset", arg->has_partial_mmap_offset);
   json_object_set_boolean(json, "has_userptr_probe", arg->has_userptr_probe);
   json_object_set_boolean(json, "has_context_isolation", arg->has_context_isolation);
   json_object_set_boolean(json, "has_set_pat_uapi", arg->has_set_pat_uapi);
   json_object_set_boolean(json, "has_indirect_unroll", arg->has_indirect_unroll);
   json_object_set_boolean(json, "has_coarse_pixel_primitive_and_cb", arg->has_coarse_pixel_primitive_and_cb);
   json_object_set_boolean(json, "has_compute_engine", arg->has_compute_engine);
   json_object_set_boolean(json, "needs_null_push_constant_tbimr_workaround", arg->needs_null_push_constant_tbimr_workaround);
   json_object_set_number(json, "num_slices", arg->num_slices);
   json_object_set_number(json, "max_slices", arg->max_slices);
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->num_subslices) / sizeof(*arg->num_subslices); ++i)
          json_array_append_number(jarray, arg->num_subslices[i]);
      json_object_set_value(json, "num_subslices", jtmp);
   }
   json_object_set_number(json, "max_subslices_per_slice", arg->max_subslices_per_slice);
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->ppipe_subslices) / sizeof(*arg->ppipe_subslices); ++i)
          json_array_append_number(jarray, arg->ppipe_subslices[i]);
      json_object_set_value(json, "ppipe_subslices", jtmp);
   }
   json_object_set_number(json, "max_eus_per_subslice", arg->max_eus_per_subslice);
   json_object_set_number(json, "num_thread_per_eu", arg->num_thread_per_eu);
   json_object_set_number(json, "grf_size", arg->grf_size);
   json_object_set_number(json, "slice_masks", arg->slice_masks);
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->subslice_masks) / sizeof(*arg->subslice_masks); ++i)
          json_array_append_number(jarray, arg->subslice_masks[i]);
      json_object_set_value(json, "subslice_masks", jtmp);
   }
   json_object_set_number(json, "subslice_total", arg->subslice_total);
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->eu_masks) / sizeof(*arg->eu_masks); ++i)
          json_array_append_number(jarray, arg->eu_masks[i]);
      json_object_set_value(json, "eu_masks", jtmp);
   }
   json_object_set_number(json, "subslice_slice_stride", arg->subslice_slice_stride);
   json_object_set_number(json, "eu_slice_stride", arg->eu_slice_stride);
   json_object_set_number(json, "eu_subslice_stride", arg->eu_subslice_stride);
   json_object_set_number(json, "l3_banks", arg->l3_banks);
   json_object_set_number(json, "max_vs_threads", arg->max_vs_threads);
   json_object_set_number(json, "max_tcs_threads", arg->max_tcs_threads);
   json_object_set_number(json, "max_tes_threads", arg->max_tes_threads);
   json_object_set_number(json, "max_gs_threads", arg->max_gs_threads);
   json_object_set_number(json, "max_wm_threads", arg->max_wm_threads);
   json_object_set_number(json, "max_threads_per_psd", arg->max_threads_per_psd);
   json_object_set_number(json, "max_cs_threads", arg->max_cs_threads);
   json_object_set_number(json, "max_cs_workgroup_threads", arg->max_cs_workgroup_threads);
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->max_scratch_ids) / sizeof(*arg->max_scratch_ids); ++i)
          json_array_append_number(jarray, arg->max_scratch_ids[i]);
      json_object_set_value(json, "max_scratch_ids", jtmp);
   }
   json_object_set_number(json, "max_scratch_size_per_thread", arg->max_scratch_size_per_thread);
   json_object_set_value(json, "urb", dump_intel_device_info_urb_desc(&arg->urb));
   json_object_set_number(json, "max_constant_urb_size_kb", arg->max_constant_urb_size_kb);
   json_object_set_number(json, "mesh_max_constant_urb_size_kb", arg->mesh_max_constant_urb_size_kb);
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->engine_class_prefetch) / sizeof(*arg->engine_class_prefetch); ++i)
          json_array_append_number(jarray, arg->engine_class_prefetch[i]);
      json_object_set_value(json, "engine_class_prefetch", jtmp);
   }
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->engine_class_supported_count) / sizeof(*arg->engine_class_supported_count); ++i)
          json_array_append_number(jarray, arg->engine_class_supported_count[i]);
      json_object_set_value(json, "engine_class_supported_count", jtmp);
   }
   json_object_set_number(json, "mem_alignment", arg->mem_alignment);
   json_object_set_number(json, "timestamp_frequency", arg->timestamp_frequency);
   json_object_set_number(json, "aperture_bytes", arg->aperture_bytes);
   json_object_set_number(json, "gtt_size", arg->gtt_size);
   json_object_set_number(json, "simulator_id", arg->simulator_id);
   json_object_set_string(json, "name", arg->name);
   json_object_set_boolean(json, "no_hw", arg->no_hw);
   json_object_set_boolean(json, "probe_forced", arg->probe_forced);
   json_object_set_value(json, "mem", dump_intel_device_info_mem_desc(&arg->mem));
   json_object_set_value(json, "pat", dump_intel_device_info_pat_desc(&arg->pat));
   {
      JSON_Value *jtmp = json_value_init_array();
      JSON_Array *jarray = json_array(jtmp);
      for (unsigned i = 0; i < sizeof(arg->cooperative_matrix_configurations) / sizeof(*arg->cooperative_matrix_configurations); ++i)
         json_array_append_value(jarray, dump_intel_cooperative_matrix_configuration(&arg->cooperative_matrix_configurations[i]));
      json_object_set_value(json, "cooperative_matrix_configurations", jtmp);
   }
   return val;
}

static void
load_intel_device_info(JSON_Object *json, struct intel_device_info *target) {
   target->kmd_type = load_intel_kmd_type(json_object_get_string(json, "kmd_type"));
   target->ver = json_object_get_number(json, "ver");
   target->verx10 = json_object_get_number(json, "verx10");
   target->gfx_ip_ver = json_object_get_number(json, "gfx_ip_ver");
   target->revision = json_object_get_number(json, "revision");
   target->gt = json_object_get_number(json, "gt");
   target->pci_domain = json_object_get_number(json, "pci_domain");
   target->pci_bus = json_object_get_number(json, "pci_bus");
   target->pci_dev = json_object_get_number(json, "pci_dev");
   target->pci_func = json_object_get_number(json, "pci_func");
   target->pci_device_id = json_object_get_number(json, "pci_device_id");
   target->pci_revision_id = json_object_get_number(json, "pci_revision_id");
   target->platform = load_intel_platform(json_object_get_string(json, "platform"));
   target->has_hiz_and_separate_stencil = json_object_get_boolean(json, "has_hiz_and_separate_stencil");
   target->has_sample_with_hiz = json_object_get_boolean(json, "has_sample_with_hiz");
   target->has_bit6_swizzle = json_object_get_boolean(json, "has_bit6_swizzle");
   target->has_llc = json_object_get_boolean(json, "has_llc");
   target->has_pln = json_object_get_boolean(json, "has_pln");
   target->has_64bit_float = json_object_get_boolean(json, "has_64bit_float");
   target->has_64bit_float_via_math_pipe = json_object_get_boolean(json, "has_64bit_float_via_math_pipe");
   target->has_64bit_int = json_object_get_boolean(json, "has_64bit_int");
   target->has_bfloat16 = json_object_get_boolean(json, "has_bfloat16");
   target->has_integer_dword_mul = json_object_get_boolean(json, "has_integer_dword_mul");
   target->has_systolic = json_object_get_boolean(json, "has_systolic");
   target->supports_simd16_3src = json_object_get_boolean(json, "supports_simd16_3src");
   target->disable_ccs_repack = json_object_get_boolean(json, "disable_ccs_repack");
   target->has_illegal_ccs_values = json_object_get_boolean(json, "has_illegal_ccs_values");
   target->has_flat_ccs = json_object_get_boolean(json, "has_flat_ccs");
   target->has_aux_map = json_object_get_boolean(json, "has_aux_map");
   target->has_caching_uapi = json_object_get_boolean(json, "has_caching_uapi");
   target->has_tiling_uapi = json_object_get_boolean(json, "has_tiling_uapi");
   target->has_ray_tracing = json_object_get_boolean(json, "has_ray_tracing");
   target->has_ray_query = json_object_get_boolean(json, "has_ray_query");
   target->has_local_mem = json_object_get_boolean(json, "has_local_mem");
   target->has_lsc = json_object_get_boolean(json, "has_lsc");
   target->has_mesh_shading = json_object_get_boolean(json, "has_mesh_shading");
   target->has_mmap_offset = json_object_get_boolean(json, "has_mmap_offset");
   target->has_partial_mmap_offset = json_object_get_boolean(json, "has_partial_mmap_offset");
   target->has_userptr_probe = json_object_get_boolean(json, "has_userptr_probe");
   target->has_context_isolation = json_object_get_boolean(json, "has_context_isolation");
   target->has_set_pat_uapi = json_object_get_boolean(json, "has_set_pat_uapi");
   target->has_indirect_unroll = json_object_get_boolean(json, "has_indirect_unroll");
   target->has_coarse_pixel_primitive_and_cb = json_object_get_boolean(json, "has_coarse_pixel_primitive_and_cb");
   target->has_compute_engine = json_object_get_boolean(json, "has_compute_engine");
   target->needs_null_push_constant_tbimr_workaround = json_object_get_boolean(json, "needs_null_push_constant_tbimr_workaround");
   target->num_slices = json_object_get_number(json, "num_slices");
   target->max_slices = json_object_get_number(json, "max_slices");
   {
      JSON_Array *array = json_object_get_array(json, "num_subslices");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->num_subslices[i] = json_array_get_number(array, i);
   }
   target->max_subslices_per_slice = json_object_get_number(json, "max_subslices_per_slice");
   {
      JSON_Array *array = json_object_get_array(json, "ppipe_subslices");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->ppipe_subslices[i] = json_array_get_number(array, i);
   }
   target->max_eus_per_subslice = json_object_get_number(json, "max_eus_per_subslice");
   target->num_thread_per_eu = json_object_get_number(json, "num_thread_per_eu");
   target->grf_size = json_object_get_number(json, "grf_size");
   target->slice_masks = json_object_get_number(json, "slice_masks");
   {
      JSON_Array *array = json_object_get_array(json, "subslice_masks");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->subslice_masks[i] = json_array_get_number(array, i);
   }
   target->subslice_total = json_object_get_number(json, "subslice_total");
   {
      JSON_Array *array = json_object_get_array(json, "eu_masks");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->eu_masks[i] = json_array_get_number(array, i);
   }
   target->subslice_slice_stride = json_object_get_number(json, "subslice_slice_stride");
   target->eu_slice_stride = json_object_get_number(json, "eu_slice_stride");
   target->eu_subslice_stride = json_object_get_number(json, "eu_subslice_stride");
   target->l3_banks = json_object_get_number(json, "l3_banks");
   target->max_vs_threads = json_object_get_number(json, "max_vs_threads");
   target->max_tcs_threads = json_object_get_number(json, "max_tcs_threads");
   target->max_tes_threads = json_object_get_number(json, "max_tes_threads");
   target->max_gs_threads = json_object_get_number(json, "max_gs_threads");
   target->max_wm_threads = json_object_get_number(json, "max_wm_threads");
   target->max_threads_per_psd = json_object_get_number(json, "max_threads_per_psd");
   target->max_cs_threads = json_object_get_number(json, "max_cs_threads");
   target->max_cs_workgroup_threads = json_object_get_number(json, "max_cs_workgroup_threads");
   {
      JSON_Array *array = json_object_get_array(json, "max_scratch_ids");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->max_scratch_ids[i] = json_array_get_number(array, i);
   }
   target->max_scratch_size_per_thread = json_object_get_number(json, "max_scratch_size_per_thread");
   load_intel_device_info_urb_desc(json_object_get_object(json, "urb"), &target->urb);
   target->max_constant_urb_size_kb = json_object_get_number(json, "max_constant_urb_size_kb");
   target->mesh_max_constant_urb_size_kb = json_object_get_number(json, "mesh_max_constant_urb_size_kb");
   {
      JSON_Array *array = json_object_get_array(json, "engine_class_prefetch");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->engine_class_prefetch[i] = json_array_get_number(array, i);
   }
   {
      JSON_Array *array = json_object_get_array(json, "engine_class_supported_count");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         target->engine_class_supported_count[i] = json_array_get_number(array, i);
   }
   target->mem_alignment = json_object_get_number(json, "mem_alignment");
   target->timestamp_frequency = json_object_get_number(json, "timestamp_frequency");
   target->aperture_bytes = json_object_get_number(json, "aperture_bytes");
   target->gtt_size = json_object_get_number(json, "gtt_size");
   target->simulator_id = json_object_get_number(json, "simulator_id");
   strncpy(target->name,
           json_object_get_string(json, "name"),
           sizeof(target->name) - 1);
   target->no_hw = json_object_get_boolean(json, "no_hw");
   target->probe_forced = json_object_get_boolean(json, "probe_forced");
   load_intel_device_info_mem_desc(json_object_get_object(json, "mem"), &target->mem);
   load_intel_device_info_pat_desc(json_object_get_object(json, "pat"), &target->pat);
   {
      JSON_Array *array = json_object_get_array(json, "cooperative_matrix_configurations");
      for (unsigned i = 0; i < json_array_get_count(array); ++i)
         load_intel_cooperative_matrix_configuration(json_array_get_object(array, i), target->cooperative_matrix_configurations + i);
   }
}

bool
intel_device_info_from_json(const char *path,
                            struct intel_device_info *devinfo) {
   JSON_Value *root = json_parse_file(path);
   JSON_Object *obj = json_object(root);
   const char *devinfo_type_sha1 = "b8a9ee447827e279a7393f0a006e79b74efdbe2e";

   /* verify that json was generated with a compatible driver */
   if (strncmp(devinfo_type_sha1,
               json_object_get_string(obj, "devinfo_type_sha1"),
               strlen(devinfo_type_sha1)))
      return false;
   load_intel_device_info(obj, devinfo);

   /* override no_hw to indicate that the GPU has been stubbed */
   devinfo->no_hw = true;

   json_value_free(root);
   intel_device_info_init_was(devinfo);
   return true;
}

JSON_Value *
intel_device_info_dump_json(const struct intel_device_info *devinfo) {
   JSON_Value * root = dump_intel_device_info(devinfo);

   /* record a hash of the structure type declaration, to prevent loading with
    * an incompatible driver
    */
   JSON_Object *obj = json_object(root);
   json_object_set_string(obj, "devinfo_type_sha1", "b8a9ee447827e279a7393f0a006e79b74efdbe2e");

   return root;
}

